// ---------------------------------------------------------------------
// Program for the Asuro Robot: Line following with obstacles.
// Auteur: Richard Lagendijk
// Datum:  08-07-2017
// ---------------------------------------------------------------------

// Include the necessary programs.
#include "asuro.h"


// Declaration of functions.
void Obstacle(void);                              // Turn around at an obstacle.


// ---------------------------------------------------------------------
// Start of program.
// ---------------------------------------------------------------------
int main(void) {
   
   Init();                                        // Init the ASURO robot.


   // Main loop
   while (1) { 

      SwitchDetection(ON);

      // Follow the line while no switch is pressed.
      while (!switchesActive) {

         // Control the motors with the line-follow sensors.
         if (lineFollowDelta > 0) {                 

            // Steer to the right.
            if (lineFollowDelta > 50) {
               MotorSpeed(100, -150);
            } else {
               MotorSpeed(150, 100);
            }

         } else { 

            // Steer to the left.
            if (lineFollowDelta < -50) {
               MotorSpeed(-150, 100);
            } else {
               MotorSpeed(100, 150);
            }

         }

      }

      Obstacle();

   }

   return 0;
}


// ---------------------------------------------------------------------
// Routine for an obstacle.
// - ASURO stops.
// - ASURO drive a short distance back.
// - ASURO turns 180 degrees.
//
// Call value  : ---
// Return value: ---
// ---------------------------------------------------------------------
void Obstacle(void) {

   MotorSpeed(0, 0);                              // Motor speed to zero and brake.
   Drive(-20, 120);                               // Drive a short distance back to make turning possible
   Turn(180, 120);                                // Turn around (180 degrees).

}
